%{
#include <string.h>
#include "y.tab.h"
#include "wdif.h"

int eerstemaal=1;
char * endptr;
char * begptr;
char *line[2];
int linepos[2]={0,0};
int lineno[2]={0,0};
int ntimes[2]={0,0};
char * vtimes[2];
double x;

YY_BUFFER_STATE b[2];
int curb;

void apekool(void) 
  {
     curb = 1-curb;
     yy_switch_to_buffer(b[curb]);
  }

void do_number_seq(char *a)
  {		
    yylval.number = strdup(a);
    ntimes[curb]--;
    apekool();
  }

%}

ws        [ \t]+
wso	  [ \t]*
id	  [+\-.a-zA-Z0-9_]+
nl        \r?\n
int	  [0-9]+
%x quote
%%

%{
if (eerstemaal) {
/* id        [^ \t\r\n,;(){}:%!@#<>/[\]?'"=`~]* */
    int i;
    eerstemaal=0;
    for (i=0; i<2; i++)
      {
        b[i] = yy_create_buffer(file[i],YY_BUF_SIZE);
        line[i] = strdup("");
        vtimes[i] = strdup("");
      }
    curb = 0;
    yy_switch_to_buffer(b[curb]);
}

if (ntimes[curb] > 0) 
  {
    do_number_seq(vtimes[curb]);
    return NUMBER;
  }

%}

^.*$	{ /* device for printing nice error message */
          free(line[curb]);
	  line[curb] = strdup(yytext); 
	  lineno[curb]++;
	  linepos[curb] = 0;
	  REJECT;
	}
{ws}      linepos[curb] += yyleng;

{int}{wso}\*{wso}{id} { linepos[curb] += yyleng;
              begptr=strchr(yytext,'*')+1;  /* skip over * */
              x = strtod(begptr,&endptr);
              if (yyleng == (int)(endptr-yytext))
                {
                  ntimes[curb] = atoi(yytext);
                  free(vtimes[curb]);
                  vtimes[curb] = strdup(begptr);
                  do_number_seq(vtimes[curb]);
                  return NUMBER;
                }
               else
                 REJECT;
             }

{id}      { linepos[curb] += yyleng;
	    x = strtod(yytext,&endptr);
	    if (yyleng == (int)(endptr-yytext))
	      {
	         yylval.number=strdup(yytext);
                 apekool();
	         return NUMBER;
 	      }
	    yylval.word=strdup(yytext);
	    apekool();
            return WORD;
          }

{nl}      { linepos[curb] += yyleng; 
	    BEGIN(INITIAL); }

<<EOF>>	  {
              apekool();
	      return ENDF;
          }


,	  { linepos[curb] += yyleng;  /* ignore comma */
            BEGIN(INITIAL);
          }

.	  { linepos[curb] += yyleng;  
	    yylval.word=strdup(yytext);
	    apekool();
            return WORD;
          }

%%
int yywrap()
{
if (0){
 unput('a'); 
 /*yy_flex_realloc(0,0); */
       } /* to quiet the compiler */
return (1);
}

